//----------------------------------------------------------------------------//

/*Función a la que se llama cada 100 milisegundos, desde la interrupción del timer1.
 Esta función hace la media de los valores medidos de temperatura de la unión fría 
 y del termopar, realiza la comensación y muestra el valor de la temperatura por pantalla.*/

//----------------------------------------------------------------------------//

void acquisition() {



//Coeficientes termopar tipo k
float C[10]={-1.760041e-2, 3.892121e-2, 1.855877e-5, -9.945759e-8, 3.1840945719e-10, -5.607285e-13, 5.6075059059e-16, -3.202072e-19, 9.715115e-23, -1.210472e-26};
float a[3]={1.185976e-1, -1.183432e-4, 126.9686};
float d1[10]={ 0, 25.17346,-1.166288, -1.083364, -8.977354e-1, -3.734238e-1, -8.663264e-2, -1.04506e-2, -5.1920577e-4, 0};
float d2[10]={ 0, 25.08355, 7.860106e-2, -2.503131e-1, 8.31527e-2, -1.228034e-2, 9.804036e-4, -4.41303e-5, 1.057734e-6,-1.052755e-8};
float d3[10]={ -131.8058, 48.30222, -1.646031, 5.464731e-2, -9.650715e-4, 8.802193e-6, -3.11081e-8, 0, 0, 0};



//Variables de adquisicion
float V0 = 0;     //Tensión amplificada del LM35
float T0 = 0;     //Temperatura leida por el LM35
float V0T = 0;    //Tensión equivalente de termopar relativa a la temperatura leida por el LM35
float V = 0;      //Tensión del termopar
float T = 0;      //Temperatura después de la compensación de la unión fría

//Declaración de Constantes 
float m0 = 50/3;     //Pendiente recta calibrado LM35 
int K = 100;            //ganacia del amplificador del termopar       
float Vref = 0.358;    //Tensión offset "Vref" del amplificador del termopar



  //Lectura de las entradas analógicas del LM35 y termopar    
  a0[DATA_counter]= analogRead (in_LM35);
  a1[DATA_counter]= analogRead (in_termocouple);

  if (DATA_counter == 9)
  {
   
    
  /*-----------------Detección de batería baja cada segundo-----------------*/  
   
    if (analogRead (LOWBATT) < lim_inf_LOWBATT)
    {
      if (SET_LOWBATT == 0)
      {
        lcd.setCursor(0,0);
        lcd.print("                ");
        lcd.setCursor (0,0);
        lcd.print ("LOW BATT");
        SET_LOWBATT = 1;
      }
    }
    else
    {
      if (analogRead (LOWBATT) > lim_sup_LOWBATT)
      {
        if (SET_LOWBATT == 1)
        {
          lcd.setCursor(0,0);
          lcd.print("                "); 
          SET_LOWBATT = 0;
        }
      }
    }
  
  /*-----------------------------------------------------------------------------*/
  

    if (analogRead(OTD) > lim_OTD)
    {
      SET_OTD=1;
      if(screen==0)
      {
        lcd.setCursor(0,1);
        lcd.print("                ");
        lcd.setCursor(10,1);
        lcd.print("Error");
      }
    }
    else
    {
    
      //media de los valores leidos del LM35
      adc0=0;
      for (int i=0; i < 10; i++)
      {
        adc0 = adc0 + a0[i];
      }
      adc0 = adc0/10;
    
      //conversión a voltaje
      V0 = 3 * adc0 / 1023; 
      //conversión a temperatura
      T0 = m0 * V0;
 
      // Transformacion a voltaje de termopar tipo k
      /*Se aplica el polinomio de cambio de temperatura a voltaje, para el termopar 
      de tipo k, para temperaturas mayores de cero */
      for (int i=9; i>0; i--)
      {
        V0T=(V0T+C[i])*T0;
      }
      V0T=C[0]+V0T+a[0]*exp(a[1]*pow(T0-a[2],2)); 
 
  
      //media de los valores leidos del termopar
      adc1=0;
      for (int i=0; i< 10; i++)
      {
        adc1 = adc1 + a1[i];
      }
      adc1 = adc1/10;
  
      //conversión a voltaje
      V = 3.0 * adc1 / 1023.0;
      V = V - Vref;
      V = V / K;
   
      //Suma del votlaje del LM35
      V= V*1000 + V0T;

      //conversión a temperatura
      /*Se aplica el polinomio de cambio de voltaje a temperatura, para el termopar 
      de tipo k, para diferentes intervalos de temperatura */

      if (V < 0)
      {   
        for (int i=9; i>0; i--)
        {
          T=(T+d1[i])*V;
        }
        T=d1[0] + T;
      }
      else
      {
        if (V < 20.644)
        {
          for (int i=9; i>0; i--)
          {    
            T=(T+d2[i])*V;        
          }
          T=d2[0] + T;    
        }
        else
        {   
          for (int i=9; i>0; i--)
          {        
            T=(T+d3[i])*V;       
          }
          T=d3[0] + T;
        }
      }
      T=T+0.9;
      //--------------------Mostrar en display la temperatura--------------------// 
      /*Si estamos en la screen 0, muestro la temperatura por pantalla. Si no, continuo
       tomando datos, pero sin mostrarlos.
       También modifico con la palabra ERROR, si el termopar se ha desconectado */
      if (screen == 0)
      {
        if(SET_OTD == 1)
        {
          lcd.setCursor(0,1);
          lcd.print("                ");
          lcd.setCursor(10,1);
          lcd.print("Error");
        }
        else
        { 
          lcd.setCursor(0,1);
          lcd.print("                ");
          lcd.setCursor(9,1);          
          lcd.print(T,1);
          lcd.setCursor (14,1);
          lcd.write(char(223));
          lcd.setCursor (15,1);
          lcd.print ("C");
          Tscreen=T;
        }
      }
      
 
      if (SET_OTD == 0)
      {
        if (T>Tmax)
        {
          Tmax=T;
        }
        if (T<Tmin)
        {
          Tmin=T;
        }
        avg=avg+T; 
        avg_counter ++;
      }
      else
      {
        SET_OTD =0;
      }
    }   
    //-------------------------------------------------------------------------//


    if(screen == 1)
    {
      time ++;
    }
    if (AUTO ==1)
    {
      t_AUTO ++;
    }
    DATA_counter = 0;
  }
  else
  {
    DATA_counter ++;
  }
}





